package com.example.f1hub.data.repository

import com.example.f1hub.data.dto.out.ads.AdAllAttributesDto
import com.example.f1hub.data.dto.out.ads.AdNoIdDto
import com.example.f1hub.data.dto.`in`.ads.ResponseAd
import com.example.f1hub.data.service.AdService
import com.example.f1hub.domain.repository.AdsRepositoryInterface
import javax.inject.Inject

class AdsRepository @Inject constructor(
    private val service: AdService
) : AdsRepositoryInterface {
    override suspend fun getAllAds(token: String): List<ResponseAd> {
        return service.getAllAds(token)
    }

    override suspend fun getAdsByTitle(title: String, token: String): List<ResponseAd> {
       return service.getAllAds(token).filter { it.title == title }
    }

    override suspend fun getAdById(token: String, id: Int): ResponseAd? {
        return service.getAdById(token, id)
    }

    override suspend fun addAd(token: String, addAd: AdNoIdDto): ResponseAd? {
        return service.addAd(token, addAd)
    }

    override suspend fun editAd(token: String, editAd: AdAllAttributesDto): ResponseAd? {
        return service.editAd(token,editAd)
    }

    override suspend fun deleteAd(token: String, id: Int): Boolean {
        return service.deleteAd(token,id)
    }

}
