package com.example.f1hub.data.repository

import com.example.f1hub.data.dto.out.items.ItemsAllAttributesDto
import com.example.f1hub.data.dto.out.items.ItemsNoIdDto
import com.example.f1hub.data.dto.`in`.items.ResponseItem
import com.example.f1hub.data.service.ItemService
import com.example.f1hub.domain.repository.ItemRepositoryInterface
import javax.inject.Inject

class ItemRepository @Inject constructor(
    private val service: ItemService
) : ItemRepositoryInterface {
    override suspend fun getAllItems(token: String): List<ResponseItem> {
        return service.getAllItems(token)
    }

    override suspend fun getAllItemsByUser(token: String, id: Int): List<ResponseItem> {
        return service.getAllItemsByUser(id,token)
    }

    override suspend fun getItemsByTitle(title: String, token: String): List<ResponseItem> {
        return service.getAllItems(token).filter { it.title == title }
    }

    override suspend fun getItemById(token: String, id: Int): ResponseItem? {
        return service.getItemById(token, id)
    }

    override suspend fun addItem(token: String, addItem: ItemsNoIdDto): ResponseItem? {
        return service.addItem(token, addItem)
    }

    override suspend fun editItem(token: String, editItem: ItemsAllAttributesDto): ResponseItem? {
        return service.editItem(token, editItem)
    }

    override suspend fun deleteItem(token: String, id: Int): Boolean {
        return service.deleteItem(token, id)
    }
}
