package com.example.f1hub.data.repository

import com.example.f1hub.data.dto.`in`.users.UserLoginResponse
import com.example.f1hub.data.dto.`in`.users.UserResponse
import com.example.f1hub.data.dto.out.users.UserAllAttributesDto
import com.example.f1hub.data.dto.out.users.UserLoginDto
import com.example.f1hub.data.dto.out.users.UserNoIdDto
import com.example.f1hub.data.service.UserService
import com.example.f1hub.domain.repository.UserRepositoryInterface
import javax.inject.Inject

class UserRepository @Inject constructor(
    private val service: UserService
) : UserRepositoryInterface {
    override suspend fun login(logUserLoginDto: UserLoginDto): UserLoginResponse? {
        return service.login(logUserLoginDto)
    }

    override suspend fun register(registerUser: UserNoIdDto): UserResponse? {
        return service.register(registerUser)
    }

    override suspend fun updateUser(token:String, editUser: UserAllAttributesDto): UserResponse? {
        return service.updateUser(token, editUser)
    }

    override suspend fun findUserById(token:String, id: Int): UserResponse? {
        return service.findUserById(token, id)
    }

    override suspend fun validateToken(token: String): Boolean {
        return service.validateToken(token)
    }
}