package com.example.f1hub.data.service

import com.example.f1hub.data.dto.`in`.users.UserLoginResponse
import com.example.f1hub.data.dto.`in`.users.UserResponse
import com.example.f1hub.data.dto.out.users.UserAllAttributesDto
import com.example.f1hub.data.dto.out.users.UserLoginDto
import com.example.f1hub.data.dto.out.users.UserNoIdDto
import com.example.f1hub.data.network.InstanceRetrofit
import retrofit2.HttpException
import retrofit2.Response
import java.io.IOException
import javax.inject.Inject

class UserService @Inject constructor() {
    suspend fun login(logUserLoginDto: UserLoginDto): UserLoginResponse?{
        val response = InstanceRetrofit.retrofitService.login(logUserLoginDto)
        return if (response.isSuccessful){
              response.body()
          } else {
              null
        }
    }

    suspend fun register(registerUser: UserNoIdDto): UserResponse?{
        val response = InstanceRetrofit.retrofitService.register(registerUser)
        return if (response.isSuccessful){
            response.body()
        } else {
            null
        }
    }

    suspend fun updateUser(token:String, editUser: UserAllAttributesDto): UserResponse?{
        val response = InstanceRetrofit.retrofitService.updateUser(token, editUser)
        return if (response.isSuccessful){
            response.body()
        } else {
            null
        }
    }

    suspend fun findUserById(token:String, id:Int): UserResponse?{
        val response = InstanceRetrofit.retrofitService.findUserById(id,token)
        return if (response.isSuccessful){
            response.body()
        } else {
            null
        }
    }

    suspend fun validateToken(token: String): Boolean{
        return try {
            val response: Response<Unit> = InstanceRetrofit.retrofitService.validateToken(token)
            response.isSuccessful
        } catch (e: IOException) {
            false
        } catch (e: HttpException) {
            false
        }
    }
}