package com.example.f1hub.di

import android.content.Context
import android.content.SharedPreferences
import dagger.Module
import dagger.Provides
import dagger.hilt.InstallIn
import dagger.hilt.android.qualifiers.ApplicationContext
import dagger.hilt.components.SingletonComponent
import javax.inject.Singleton

@Module
@InstallIn(SingletonComponent::class)
object AppModule {
    private const val TOKEN_KEY = "auth_token"
    private const val USER_KEY = "user_id"
    @Provides
    @Singleton
    fun provideSharedPreferences(@ApplicationContext context: Context): SharedPreferences {
        return context.getSharedPreferences(TOKEN_KEY, Context.MODE_PRIVATE)
    }
    // 🔹 Devolver token
    @Provides
    fun provideToken(prefs: SharedPreferences): String {
        return prefs.getString(TOKEN_KEY, "") ?: ""
    }
    // 🔹 Id del usuario que ha iniciado sesión
    @Provides
    fun provideUserId(prefs: SharedPreferences): Int {
        return prefs.getInt(USER_KEY, 0)
    }
}
