package com.example.f1hub.domain.repository

import com.example.f1hub.data.dto.out.ads.AdAllAttributesDto
import com.example.f1hub.data.dto.out.ads.AdNoIdDto
import com.example.f1hub.data.dto.`in`.ads.ResponseAd

// Interfaz que define las operaciones para obtener anuncios.
// Permite recuperar todos los anuncios o filtrarlos por título.
interface AdsRepositoryInterface {
    suspend fun getAllAds(token: String): List<ResponseAd>

    suspend fun getAdsByTitle(title: String, token: String): List<ResponseAd>

    suspend fun getAdById(token: String,id: Int): ResponseAd?

    suspend fun addAd(token: String, addAd: AdNoIdDto): ResponseAd?

    suspend fun editAd(token: String,editAd: AdAllAttributesDto): ResponseAd?

    suspend fun deleteAd(token: String,id: Int): Boolean

}