package com.example.f1hub.domain.repository

import com.example.f1hub.data.dto.out.items.ItemsAllAttributesDto
import com.example.f1hub.data.dto.out.items.ItemsNoIdDto
import com.example.f1hub.data.dto.`in`.items.ResponseItem

interface ItemRepositoryInterface {
    suspend fun getAllItems(token: String): List<ResponseItem>

    suspend fun getAllItemsByUser(token: String, id:Int): List<ResponseItem>

    suspend fun getItemsByTitle(title: String, token: String): List<ResponseItem>

    suspend fun getItemById(token: String, id: Int): ResponseItem?

    suspend fun addItem(token: String, addItem: ItemsNoIdDto): ResponseItem?

    suspend fun editItem(token: String,editItem: ItemsAllAttributesDto): ResponseItem?

    suspend fun deleteItem(token: String,id: Int): Boolean

}