package com.example.f1hub.domain.repository

import com.example.f1hub.data.dto.`in`.users.UserLoginResponse
import com.example.f1hub.data.dto.`in`.users.UserResponse
import com.example.f1hub.data.dto.out.users.UserAllAttributesDto
import com.example.f1hub.data.dto.out.users.UserLoginDto
import com.example.f1hub.data.dto.out.users.UserNoIdDto

interface UserRepositoryInterface {
    suspend fun login(logUserLoginDto: UserLoginDto): UserLoginResponse?

    suspend fun register(registerUser: UserNoIdDto): UserResponse?

    suspend fun updateUser(token:String, editUser: UserAllAttributesDto): UserResponse?

    suspend fun findUserById(token:String, id: Int): UserResponse?

    suspend fun validateToken(token: String) : Boolean

}