package com.example.f1hub.ui.adapter

import android.view.View
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.example.f1hub.R
import com.example.f1hub.data.dto.`in`.ads.ResponseAd
import com.example.f1hub.databinding.CardViewGeneralBinding

// ViewHolder para manejar la vista de un anuncio en el RecyclerView
class ViewHolderAnuncio(view: View) :
    RecyclerView.ViewHolder(view) {

    private val binding = CardViewGeneralBinding.bind(view)

    // Método para actualizar la vista con los datos del anuncio
    fun renderize(ad: ResponseAd) {
        binding.title.text = ad.title

        // 🖼️ Cargar imagen en formato circular con Glide
        Glide.with(binding.imagen.context)
            .load(ad.image)
            .placeholder(R.drawable.loading_bar)
            .error(R.drawable.not_found)
            .transform(CircleCrop())
            .into(binding.imagen)
    }
}
