package com.example.f1hub.ui.adapter

import android.view.View
import androidx.recyclerview.widget.RecyclerView
import com.bumptech.glide.Glide
import com.bumptech.glide.load.engine.DiskCacheStrategy
import com.bumptech.glide.load.resource.bitmap.CircleCrop
import com.example.f1hub.R
import com.example.f1hub.data.dto.`in`.items.ResponseItem
import com.example.f1hub.databinding.CardViewPropioBinding

class ViewHolderItem(
    view: View
) : RecyclerView.ViewHolder(view) {

    private val bindingItem: CardViewPropioBinding = CardViewPropioBinding.bind(view)

    fun renderize(item: ResponseItem) {
        bindingItem.title.text = item.title
        bindingItem.type.text = item.type
        bindingItem.country.text = item.country

        // 🖼️ Cargar imagen en formato circular con Glide
        Glide.with(bindingItem.imagen.context)
            .load(item.image)
            .placeholder(R.drawable.loading_bar)
            .error(R.drawable.not_found)
            .transform(CircleCrop())
            .into(bindingItem.imagen)

    }
}
